#include "ObjectWindow.hxx"
#include "ui_ObjectWindow.h"

// --- constructors and deconstructors ---

ObjectWindow::ObjectWindow(QWidget *parent)
: QMainWindow(parent), _ui(new Ui::ObjectWindow), _num(0)
{
    _ui->setupUi(this);

    setupActions();
    setMode(Mode::Fresh);
}

ObjectWindow::~ObjectWindow()
{
    delete _ui;
}

// --- public slots ---

void ObjectWindow::slotObjectSave()
{
}

void ObjectWindow::slotObjectDiscard()
{
    _entry = NCFile();
    _num = 0;

    emit sigObjectIgnored();
}

void ObjectWindow::slotObjectView(NCFile& entry, quint32 row)
{
    _entry = entry;
    _num = row;
}

// --- protected methods ---

void ObjectWindow::changeEvent(QEvent *event)
{
    if (event->type() == QEvent::LanguageChange)
        _ui->retranslateUi(this);
    else
        QMainWindow::changeEvent(event);
}

void ObjectWindow::setMode(const Mode mode)
{
    switch (mode)
    {
        case Mode::Edited:
            _ui->act_object_save->setEnabled(true);

            break;

        case Mode::Fresh:
        default:
            _ui->act_object_save->setEnabled(false);
    }
}

void ObjectWindow::setupActions()
{
    connect(_ui->act_object_save, SIGNAL(triggered()),
            this, SLOT(slotObjectSave()));
    connect(_ui->act_object_cancel, SIGNAL(triggered()),
            this, SLOT(slotObjectDiscard()));
}
