#pragma once

#include <QMainWindow>
#include "filesystem/NCFile.hxx"

namespace Ui
{
    class ObjectWindow;
}

class ObjectWindow : public QMainWindow {
    Q_OBJECT
signals:
    void sigObjectUpdate(NCFile& entry, quint32 row) const;
    void sigObjectIgnored();

public:
    enum class Mode : quint8 {
        Fresh,
        Edited
    };

    explicit ObjectWindow(QWidget *parent = 0);
    virtual ~ObjectWindow();

public slots:
    void slotObjectSave();
    void slotObjectDiscard();

    void slotObjectView(NCFile& entry, quint32 row);

protected:
    virtual void changeEvent(QEvent *event);
    void setMode(const Mode mode = Mode::Fresh);
    void setupActions();

private:
    Ui::ObjectWindow *_ui;
    NCFile _entry;
    quint32 _num;
};
