#pragma once

#include <QObject>
#include "common/NCTypes.hxx"

class FileIdentifier : public QObject {
    Q_OBJECT
public:
    // internal typedefs
    using IdentifyType = NC::Identify::Type;

    // internal constants
    enum : quint32 {
        Error = NC::Meta::Error,
        VFS = NC::Identify::VFS,
        PAK1 = NC::Identify::PAK1,
        PAK2 = NC::Identify::PAK2,
        PAK3 = NC::Identify::PAK3,
        Plain = NC::Identify::Plain,
        ZLIB = NC::Identify::ZLIB
    };

    // constructors and deconstructors
    FileIdentifier(QObject *parent = 0);
    FileIdentifier(const FileIdentifier& rhs) = delete;
    FileIdentifier(const FileIdentifier&& rhs) = delete;
    virtual ~FileIdentifier();

    // operators
    FileIdentifier& operator=(const FileIdentifier& rhs) = delete;
    FileIdentifier& operator=(const FileIdentifier&& rhs) = delete;

    // public methodes
    IdentifyType identify(const QString& filename) const;
    IdentifyType identify(const QByteArray& stream) const;

    QString identifyName(const IdentifyType& type) const;
    QString identifyName(const QString& filename) const;
    QString identifyName(const QByteArray& stream) const;

protected:
    // protected methods
    IdentifyType identifyData(const quint32& data) const;
};
